--[[
 ▄████▄   ██▀███   ██▓▄▄▄█████▓    ▒█████   ██▒   █▓▓█████  ██▀███   ██ ▄█▀ ██▓ ██▓     ██▓    
▒██▀ ▀█  ▓██ ▒ ██▒▓██▒▓  ██▒ ▓▒   ▒██▒  ██▒▓██░   █▒▓█   ▀ ▓██ ▒ ██▒ ██▄█▒ ▓██▒▓██▒    ▓██▒    
▒▓█    ▄ ▓██ ░▄█ ▒▒██▒▒ ▓██░ ▒░   ▒██░  ██▒ ▓██  █▒░▒███   ▓██ ░▄█ ▒▓███▄░ ▒██▒▒██░    ▒██░    
▒▓▓▄ ▄██▒▒██▀▀█▄  ░██░░ ▓██▓ ░    ▒██   ██░  ▒██ █░░▒▓█  ▄ ▒██▀▀█▄  ▓██ █▄ ░██░▒██░    ▒██░    
▒ ▓███▀ ░░██▓ ▒██▒░██░  ▒██▒ ░    ░ ████▓▒░   ▒▀█░  ░▒████▒░██▓ ▒██▒▒██▒ █▄░██░░██████▒░██████▒
░ ░▒ ▒  ░░ ▒▓ ░▒▓░░▓    ▒ ░░      ░ ▒░▒░▒░    ░ ▐░  ░░ ▒░ ░░ ▒▓ ░▒▓░▒ ▒▒ ▓▒░▓  ░ ▒░▓  ░░ ▒░▓  ░
  ░  ▒     ░▒ ░ ▒░ ▒ ░    ░         ░ ▒ ▒░    ░ ░░   ░ ░  ░  ░▒ ░ ▒░░ ░▒ ▒░ ▒ ░░ ░ ▒  ░░ ░ ▒  ░
░          ░░   ░  ▒ ░  ░         ░ ░ ░ ▒       ░░     ░     ░░   ░ ░ ░░ ░  ▒ ░  ░ ░     ░ ░   
░ ░         ░      ░                  ░ ░        ░     ░  ░   ░     ░  ░    ░      ░  ░    ░  ░
░                                               ░                                              
By Kumartheffar a.k.a. Colin Firth
--]]

local Splot=CreateFrame("Frame", "Bloodspot")

if maximumblood == nil then maximumblood = 20 ;end
if maxsize == nil then maxsize = 4 ;end
if maxalpha == nil then maxalpha = 1; end
if fadeout == nil then fadeout = 3; end
if Drip == nil then Drip = 5; end

local sizes = {64,128,256,512}
local Crit = 0 --Create Reset for crit fader
local Blood = {} --Create Array for Blood
local BloodAlpha = {} --Create Array for BloodAlpha
local Xpos = {} --Xpos of blood
local Ypos = {} --Ypos of blood
local Slide = {}
--Fill Arrays with default value
for i = 1, maximumblood do
	Blood[i] = 0
	BloodAlpha[i] = 0
	Xpos[i] = 0
	Ypos[i] = 0
	Slide[i] = math.random(10)/15
end

--Generate total blood objects
for i = 1, maximumblood do
   backdrop = {
      bgFile="Interface\\AddOns\\CritOverkill\\Images\\BloodDrop"..math.random(5)..".tga",
      edgeFile="",
      tile = false,
      edgesize=0,
   }
   Splot[i]=CreateFrame("Frame", "Bloodspot"..i)
   Splot[i]:SetBackdrop(backdrop)
   Splot[i]:SetAlpha(1)
   Splot[i]:Show()
end

function round(val, decimal)
	local exp = decimal and 10^decimal or 1
	return math.ceil(val * exp - 0.5) / exp
end

--CombatLog Event
function EventHandler(self, event, ...)
   local myself = UnitName("player")
   if event == "COMBAT_LOG_EVENT_UNFILTERED" then
      local timestamp, type, hideCaster, sourceGUID, sourceName, sourceFlags, sourceFlags2, destGUID, destName, destFlags, destFlags2 = select(1, ...)
      if type == "SPELL_DAMAGE" and sourceName == myself then
         local spellId, spellName, spellSchool = select(12, ...)
         local amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing = select(15, ...)
		 local factor = (amount/(amount-overkill))*2
         if overkill > 1 then
			if factor > maximumblood then factor = maximumblood; end
			for i = 1, factor do
				Xpos[i] = math.random(-100,200)
				Ypos[i] = math.random(-100,250)
				scale = sizes[math.random(maxsize)]
			    Splot[i]:SetWidth(scale)
				Splot[i]:SetHeight(scale)
				Splot[i]:SetPoint("CENTER",UIParent, "CENTER", Xpos[i] ,Ypos[i])
				Blood[i] = 0
			end
			PlaySoundFile("Interface\\AddOns\\CritOverkill\\SFX\\Splat.ogg", "Master")
		 end
         if critical then
			Crit = .4
         end
      end 
   end
end

--Blood fadeout
function Crit_OnUpdate(self, elapsed)
	Crit = Crit + elapsed;
	CritAlpha=1-Crit
	for b = 1, maximumblood do
		Blood[b] = Blood[b] + elapsed
		BloodAlpha[b] = 1.1-Blood[b]*1/fadeout
	end
	Crit_Frame:SetAlpha(CritAlpha)
	for i = 1, maximumblood do
		Splot[i]:SetAlpha(BloodAlpha[i])
		Splot[i]:SetPoint("CENTER",UIParent, "CENTER", Xpos[i] ,(((math.cos(Blood[i]+Slide[i]/(Drip/math.pi))*Drip)-Drip)*16)+Ypos[i])
	end
end

--Slash Commands
SLASH_MAXBLOOD1 = '/crokmb'
function SlashCmdList.MAXBLOOD(argmb)
    if tonumber(argmb) == nil then
        print("Maximum blood dots: "..maximumblood)
    else
        maximumblood = tonumber(argmb)
        print("Maximum blood dots is now: "..maximumblood)
    end
end

SLASH_MAXSIZE1 = '/crokms'
function SlashCmdList.MAXSIZE(argms)
    if tonumber(argms) == nil then
        print("Maximum tile size is: "..sizes[maxsize])
    else
        maxsize = tonumber(argms)
        print("Maximum tile size is now: "..sizes[maxsize])
    end
end

SLASH_MAXALPHA1 = '/crokma'
function SlashCmdList.MAXALPHA(argma)
    if tonumber(argma) == nil then
        print("Maximum Blood Alpha is: "..(maxalpha*100).."%")
    else
        maxalpha = tonumber(argma/100)
        print("Maximum Blood Alpha is now: "..(maxalpha*100).."%")
    end
end

SLASH_CFADEOUT1 = '/crokfo'
function SlashCmdList.CFADEOUT(argfo)
    if tonumber(argfo) == nil then
        print("Blood Fadout is: "..fadeout)
    else
        fadeout = tonumber(argfo)
        print("Blood Fadout is now: "..fadeout)
    end
end

SLASH_CDRIP1 = '/crokdr'
function SlashCmdList.CDRIP(argdr)
    if tonumber(argdr) == nil then
        print("Blood Drip is: "..Drip)
    else
        Drip = tonumber(argdr)
        print("Blood Drip is now: "..Drip)
    end
end

SLASH_CRITOVERKILL1 = '/crok'
function SlashCmdList.CRITOVERKILL()
	print("|cff990000Crit |cffFFFFFFOverkill")
	print("|cff92C7C7/crokmb|cffF9966B <number>|cffFFFFFF - Max Bloodspots=|cffFFF380 "..maximumblood)
	print("|cff92C7C7/crokms|cffF9966B 1-4|cffFFFFFF - Max size is|cffFFF380 "..maxsize.." ("..sizes[maxsize]..")px")
	print("|cff92C7C7/crokma|cffF9966B 1-100|cffFFFFFF - Max Opacity is|cffFFF380 "..(maxalpha*100).."%")
	print("|cff92C7C7/crokfo|cffF9966B <seconds>|cffFFFFFF - fadeout time is|cffFFF380 "..fadeout)
end
-- Addon Welcome Message
print("|cff990000Crit |cffFFFFFFOverkill Loaded ;)")
print("|cff92C7C7/crokmb|cffF9966B <number>|cffFFFFFF - Max Bloodspots=|cffFFF380 "..maximumblood)
print("|cff92C7C7/crokms|cffF9966B 1-4|cffFFFFFF - Max size is|cffFFF380 "..maxsize.." ("..sizes[maxsize]..")px")
print("|cff92C7C7/crokma|cffF9966B 1-100|cffFFFFFF - Max Opacity is|cffFFF380 "..(maxalpha*100).."%")
print("|cff92C7C7/crokfo|cffF9966B <seconds>|cffFFFFFF - fadeout time is|cffFFF380 "..fadeout)